package com.jasamedika.medifirst2000.entities;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jasamedika.medifirst2000.base.BaseTransaction;
import com.jasamedika.medifirst2000.helper.Caption;import org.hibernate.envers.Audited;

@Entity
@Table(name = "PapKebutuhanEdukasi_T")
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class PapKebutuhanEdukasi extends BaseTransaction {
	
	@ManyToOne
	@JoinColumn(name = "ObjectPasienFk")
	@NotNull(message = "Pasien tidak boleh kosong")
	private AntrianPasienDiPeriksa pasienDaftar;
	
	@NotNull(message = "Tgl Input tidak boleh kosong")
	@Column(name = "tglInput", nullable = false)
	@Caption(value = "Tgl Input")
	private Date tglInput;
	
	@OneToMany(cascade=CascadeType.ALL,fetch = FetchType.LAZY, mappedBy = "kebutuhanEdukasi")
	private Set<PapTransaksiHambatanPembelajaran> hambatanPembelajaran=new HashSet<PapTransaksiHambatanPembelajaran>();
	
	@OneToMany(cascade=CascadeType.ALL,fetch = FetchType.LAZY, mappedBy = "kebutuhanEdukasi")
	private Set<PapTransaksiEdukasi> edukasiYgDiperlukan=new HashSet<PapTransaksiEdukasi>();
	
	@ManyToOne(fetch=FetchType.LAZY)
	@Caption(value = "pengkajianAwalBaru")
	@JoinColumn(name = "ObjectPengkajianAwalBaruFk")
	private PengkajianAwalBaru pengkajianAwalBaru;
	
	@Column(name = "ObjectPengkajianAwalBaruFk", columnDefinition = "CHAR(32)", insertable = false, updatable = false)
	private String pengkajianAwalBaruId;

	public AntrianPasienDiPeriksa getPasien() {
		return pasienDaftar;
	}

	public void setPasien(AntrianPasienDiPeriksa pasien) {
		this.pasienDaftar = pasien;
	}

	

	public Date getTglInput() {
		return tglInput;
	}

	public void setTglInput(Date tglInput) {
		this.tglInput = tglInput;
	}

	public Set<PapTransaksiHambatanPembelajaran> getHambatanPembelajaran() {
		return hambatanPembelajaran;
	}

	public void setHambatanPembelajaran(Set<PapTransaksiHambatanPembelajaran> hambatanPembelajaran) {
		this.hambatanPembelajaran = hambatanPembelajaran;
	}

	public Set<PapTransaksiEdukasi> getEdukasiYgDiperlukan() {
		return edukasiYgDiperlukan;
	}

	public void setEdukasiYgDiperlukan(Set<PapTransaksiEdukasi> edukasiYgDiperlukan) {
		this.edukasiYgDiperlukan = edukasiYgDiperlukan;
	}

	public PengkajianAwalBaru getPengkajianAwalBaru() {
		return pengkajianAwalBaru;
	}

	public void setPengkajianAwalBaru(PengkajianAwalBaru pengkajianAwalBaru) {
		this.pengkajianAwalBaru = pengkajianAwalBaru;
	}

	public String getPengkajianAwalBaruId() {
		return pengkajianAwalBaruId;
	}

	public void setPengkajianAwalBaruId(String pengkajianAwalBaruId) {
		this.pengkajianAwalBaruId = pengkajianAwalBaruId;
	}

	
	
}
